/*
 * playerlist.c
 */
#include "copyright.h"

#include <stdio.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

static char *classes[NUM_TYPES] = {
	"SC", "DD", "CA", "BB", "AS", "SB", "??"
};

playerlist()
{
    int i;
    char buf[100];

    W_ClearWindow(playerw);
    (void) strcpy(buf, "  Type Rank      Name            Kills   Win  Loss  Ratio Offense Defense     DI");
    W_WriteText(playerw, 0, 1, textColor, buf, strlen(buf), W_RegularFont);
    for (i=0; i<MAXPLAYER; i++) {
	updatePlayer[i]=1;
    }
    playerlist2();
}

playerlist2()
{
    register int i;
    char buf[100];
    register struct player *j;
    int kills, losses;
    double ratio;
    float pRating, oRating, dRating, bRating;

    if (!W_IsMapped(playerw)) return;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if (!updatePlayer[i]) continue;
	updatePlayer[i]=0;
	if (j->p_status != PALIVE) {
	    W_ClearArea(playerw, 0, i+2, 83, 1, backColor);
	    continue;
	}
	if (j->p_ship.s_type == STARBASE) {
	    kills=j->p_stats.st_sbkills;
	    losses=j->p_stats.st_sblosses;
	} else {
	    kills=j->p_stats.st_kills + j->p_stats.st_tkills;
	    losses=j->p_stats.st_losses + j->p_stats.st_tlosses;
	}
	if (losses==0) {
	    ratio=kills;
	} else {
	    ratio=(double) kills/losses;
	}
	oRating = offenseRating(j);
	dRating = defenseRating(j);
	pRating = planetRating(j);
	bRating = bombingRating(j);
	(void) sprintf(buf, "%c%c %s  %-9.9s %-16.16s%5.2f %5d %5d %6.2lf   %5.2f   %5.2f %8.2f",
	    teamlet[j->p_team],
	    shipnos[j->p_no],
	    classes[j->p_ship.s_type],
	    ranks[j->p_stats.st_rank].name,
	    j->p_name,
	    j->p_kills,
	    kills,
	    losses,
	    ratio,
	    oRating,
	    dRating,
	    (oRating+pRating+bRating)*(j->p_stats.st_tticks/36000.0));
	W_WriteText(playerw, 0, i+2, playerColor(j), buf, strlen(buf),
	    shipFont(j));
    }
}
