/*
 * redraw.c
 */
#include "copyright.h"

#include <stdio.h>
#include <signal.h>
#include <math.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

static int clearzone[4][(MAXTORP + 1) * MAXPLAYER + 
			(MAXPLASMA + 1) * MAXPLAYER + MAXPLANETS];
static int clearcount;
static int clearline[4][MAXPLAYER];
static int clearlcount;
static int mclearzone[6][MAXPLAYER];	/* For map window */

static short nplayers;

intrupt()
{
    static long lastread;
    long time();

    udcounter++;
    if (readFromServer()) {
	lastread=time(NULL);
	redraw();
	playerlist2();
    }
    if (reinitPlanets) {
	initPlanets();
	reinitPlanets=0;
    }
    if (lastread+3 < time(NULL)) {
	/* We haven't heard from server for awhile... 
	 * Strategy:  send a useless packet to "ping" server.
	 */
	sendWarReq(me->p_hostile);
    }
    if (me->p_status==POUTFIT) {
	death();
    }
}

redraw()
{

    /* erase warning line if necessary */
    if ((warntimer <= udcounter) && (warncount > 0)) {
	W_ClearArea(warnw, 5, 5, W_Textwidth * warncount, W_Textheight, backColor);
	warncount = 0;
    }

    if (W_FastClear) {
	W_ClearWindow(w);
	clearcount=0;
	clearlcount=0;
    } else {
	while (clearcount) {
	    clearcount--;
	    W_ClearArea(w, clearzone[0][clearcount], clearzone[1][clearcount],
		clearzone[2][clearcount], clearzone[3][clearcount],
		backColor);
	}
	while (clearlcount) {
	    clearlcount--;
	    W_MakeLine(w, clearline[0][clearlcount], clearline[1][clearlcount],
		clearline[2][clearlcount], clearline[3][clearlcount],
		backColor);
	}
    }

    if (mapmode) map();

    local();	/* redraw local window */

    stline(0);

    if (W_IsMapped(statwin))
	updateStats(statwin);
}

W_Icon planetBitmap(p)
register struct planet *p;
{
    int i;

    if (showlocal==2) {
	return(bplanets[0]);
    } else if (p->pl_info & me->p_team) {
	if (showlocal==1) {
	    i=0;
	    if (p->pl_armies > 4) i+=4;
	    if (p->pl_flags & PLREPAIR) i+=2;
	    if (p->pl_flags & PLFUEL) i+=1;
	    return(bplanets2[i]);
	} else {
	    return(bplanets[remap[p->pl_owner]]);
	}
    } else {
	return(bplanets[5]);
    }
}


W_Icon planetmBitmap(p)
register struct planet *p;
{
    int i;

    if (showgalactic==2) {
	return(mbplanets[0]);
    } else if (p->pl_info & me->p_team) {
	if (showgalactic==1) {
	    i=0;
	    if (p->pl_armies > 4) i+=4;
	    if (p->pl_flags & PLREPAIR) i+=2;
	    if (p->pl_flags & PLFUEL) i+=1;
	    return(mbplanets2[i]);
	} else {
	    return(mbplanets[remap[p->pl_owner]]);
	}
    } else {
	return(mbplanets[5]);
    }
}

local()
{
    register int h, i;
    register struct player *j;
    register struct torp *k;
    register struct planet *l;
    register struct phaser *php;
    register struct plasmatorp *pt;

    int dx, dy;
    int view;
    char idbuf[2];
    W_Icon (*ship_bits)[VIEWS];

    /* Kludge to try to fix missing ID chars on tactical (short range) display. */
    idbuf[0] = '0';
    idbuf[1] = '\0';
    /* Draw Planets */
    view = SCALE * WINSIDE / 2;
    for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++) {
	dx = l->pl_x - me->p_x;
	dy = l->pl_y - me->p_y;
	if (dx > view || dx < -view || dy > view || dy < -view)
	    continue;
	dx = dx / SCALE + WINSIDE / 2;
	dy = dy / SCALE + WINSIDE / 2;
	W_WriteBitmap(dx - (planet_width/2), dy - (planet_height/2),
	    planetBitmap(l), planetColor(l));
	if (namemode) {
	    W_MaskText(w, dx - (planet_width/2), dy + (planet_height/2),
		planetColor(l), l->pl_name, l->pl_namelen,
		planetFont(l));
	    clearzone[0][clearcount] = dx - (planet_width/2);
	    clearzone[1][clearcount] = dy + (planet_height/2);
	    clearzone[2][clearcount] = W_Textwidth * l->pl_namelen;
	    clearzone[3][clearcount] = W_Textheight;
	    clearcount++;
	}
	clearzone[0][clearcount] = dx - (planet_width/2);
	clearzone[1][clearcount] = dy - (planet_height/2);
	clearzone[2][clearcount] = planet_width;
	clearzone[3][clearcount] = planet_height;
	clearcount++;
    }

    /* Draw ships */
    nplayers = 0;
    view = SCALE * WINSIDE / 2;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
        int tx, ty;
	if ((j->p_status != PALIVE) && (j->p_status != PEXPLODE))
	    continue;
	nplayers++;
	if (j->p_flags & PFCLOAK) {
	    if (j->p_cloakphase < (CLOAK_PHASES-1)) {
		j->p_cloakphase++;
	    }
	} else {
	    if (j->p_cloakphase) {
		j->p_cloakphase--;
	    }
	}
	dx = j->p_x - me->p_x;
	dy = j->p_y - me->p_y;
	if (dx > view || dx < -view || dy > view || dy < -view) 
	    continue;
	dx = dx / SCALE + WINSIDE / 2;
	dy = dy / SCALE + WINSIDE / 2;
	if (j->p_flags & PFCLOAK && (j->p_cloakphase == (CLOAK_PHASES-1))) {
	    if (myPlayer(j)) {
		W_WriteBitmap(dx - (cloak_width/2), dy - (cloak_height/2),
		    cloakicon, myColor);
		clearzone[0][clearcount] = dx - (shield_width/2);
		clearzone[1][clearcount] = dy - (shield_height/2);
		clearzone[2][clearcount] = shield_width;
		clearzone[3][clearcount] = shield_height;
		clearcount++;
	    }
	    continue;
	}
	if (j->p_status == PALIVE) {
	    switch (j->p_team) {
		case FED:
		    ship_bits = fed_bitmaps;
		    break;
		case ROM:
		    ship_bits = rom_bitmaps;
		    break;
		case KLI:
		    ship_bits = kli_bitmaps;
		    break;
		default:
		    ship_bits = ori_bitmaps;
		    break;
	    }

	    clearzone[0][clearcount] = dx - (shield_width/2);
	    clearzone[1][clearcount] = dy - (shield_height/2);
	    clearzone[2][clearcount] = shield_width;
	    clearzone[3][clearcount] = shield_height;
	    clearcount++;

	    W_WriteBitmap(dx - (j->p_ship.s_width/2),
		dy - (j->p_ship.s_height/2),
		ship_bits[j->p_ship.s_type][rosette(j->p_dir)],
		playerColor(j));

            if (j->p_cloakphase > 0) {
		W_WriteBitmap(dx - (cloak_width/2),
		    dy - (cloak_height/2), cloakicon, playerColor(j));
		continue;
	    }

	    if (showShields && (j->p_flags & PFSHIELD)) {
		W_WriteBitmap(dx - (shield_width/2),
		    dy - (shield_height/2), shield, playerColor(j));
	    }

	    idbuf[0] = *(shipnos+j->p_no);

	    W_MaskText(w, dx + (j->p_ship.s_width/2), 
		dy - (j->p_ship.s_height/2), playerColor(j),
		idbuf, 1, shipFont(j));
	       
	    clearzone[0][clearcount] = dx + (j->p_ship.s_width/2);
	    clearzone[1][clearcount] = dy - (j->p_ship.s_height/2);
	    clearzone[2][clearcount] = W_Textwidth;
	    clearzone[3][clearcount] = W_Textheight;
	    clearcount++;
	}
	else if (j->p_status == PEXPLODE) {
	    int i;

	    i=j->p_explode;
	    if (i<EX_FRAMES || (i<SBEXPVIEWS && j->p_ship.s_type==STARBASE)) {

		if (j->p_ship.s_type == STARBASE) {
		    W_WriteBitmap(dx - (sbexp_width/2), 
			dy - (sbexp_height/2), sbexpview[i], 
			playerColor(j));
		    clearzone[0][clearcount] = dx - (sbexp_width/2);
		    clearzone[1][clearcount] = dy - (sbexp_height/2);
		    clearzone[2][clearcount] = sbexp_width;
		    clearzone[3][clearcount] = sbexp_height;
		} else {
		    W_WriteBitmap(dx - (ex_width/2), dy - (ex_height/2),
			expview[i], playerColor(j));
		    clearzone[0][clearcount] = dx - (ex_width/2);
		    clearzone[1][clearcount] = dy - (ex_height/2);
		    clearzone[2][clearcount] = ex_width;
		    clearzone[3][clearcount] = ex_height;
		}
	        clearcount++;
		j->p_explode++;    
	    }
	}
	/* Now draw his phaser (if it exists) */
	php = &phasers[j->p_no];
	if (php->ph_status != PHFREE) {
	    if (php->ph_status == PHMISS) {
		/* Here I will have to compute end coordinate */
		tx = j->p_x + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Cos[php->ph_dir];
		ty = j->p_y + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Sin[php->ph_dir];
		tx = (tx - me->p_x) / SCALE + WINSIDE / 2;
		ty = (ty - me->p_y) / SCALE + WINSIDE / 2;
		php->ph_fuse = 0;
	    } else if (php->ph_status == PHHIT2) {
		tx = (php->ph_x - me->p_x) / SCALE + WINSIDE / 2;
		ty = (php->ph_y - me->p_y) / SCALE + WINSIDE / 2;
	    } else { /* Start point is dx, dy */
		tx = (players[php->ph_target].p_x - me->p_x) /
		    SCALE + WINSIDE / 2;
		ty = (players[php->ph_target].p_y - me->p_y) /
		    SCALE + WINSIDE / 2;
	    }

	    /* Scott: 9/30/90: 5 lines */
	    if ((php->ph_fuse % 2) == 1)
		W_MakeLine(w, dx, dy, tx, ty, foreColor);
	    else
		W_MakeLine(w, dx, dy, tx, ty, shipCol[remap[j->p_team]]);
	    php->ph_fuse++;

	    /* OLD: W_MakeLine(w,dx, dy, tx, ty,phaserColor(php)); */

	    clearline[0][clearlcount] = dx;
	    clearline[1][clearlcount] = dy;
	    clearline[2][clearlcount] = tx;
	    clearline[3][clearlcount] = ty;
	    clearlcount++;
	}
    }
    /* Draw torps */
    view = SCALE * WINSIDE / 2;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if (!j->p_ntorp)
	    continue;
	for (h = 0, k = &torps[MAXTORP * i + h]; h < MAXTORP; h++, k++) {
	    if (!k->t_status)
		continue;
	    dx = k->t_x - me->p_x;
	    dy = k->t_y - me->p_y;
	    if (dx > view || dx < -view || dy > view || dy < -view) {
		/* Call any torps off screen "free" (if owned by other) */
		if (k->t_status==TEXPLODE && j!=me) {
		    k->t_status=TFREE;
		    j->p_ntorp--;
		}
		continue;
	    }
	    dx = dx / SCALE + WINSIDE / 2;
	    dy = dy / SCALE + WINSIDE / 2;
	    if (k->t_status == TEXPLODE) {
		k->t_fuse--;
		if (k->t_fuse <= 0) {
		    k->t_status=TFREE;
		    j->p_ntorp--;
		    continue;
		}
		if (k->t_fuse>=NUMDETFRAMES) {
		    k->t_fuse=NUMDETFRAMES-1;
		}
		W_WriteBitmap(dx - (cloud_width/2), dy - (cloud_height/2),
		    cloud[k->t_fuse], torpColor(k));
		clearzone[0][clearcount] = dx - (cloud_width/2);
		clearzone[1][clearcount] = dy - (cloud_height/2);
		clearzone[2][clearcount] = cloud_width;
		clearzone[3][clearcount] = cloud_height;
		clearcount++;
	    }
	    else if (k->t_owner != me->p_no && ((k->t_war & me->p_team) ||
		      (players[k->t_owner].p_team & (me->p_hostile | me->p_swar))))
	    {
		W_WriteBitmap(dx - (etorp_width/2), dy - (etorp_height/2),
		    etorp, torpColor(k));
		clearzone[0][clearcount] = dx - (etorp_width/2);
		clearzone[1][clearcount] = dy - (etorp_height/2);
		clearzone[2][clearcount] = etorp_width;
		clearzone[3][clearcount] = etorp_height;
		clearcount++;
	    }
	    else {
		W_WriteBitmap(dx - (mtorp_width/2), dy - (mtorp_height/2),
		    mtorp, torpColor(k));
		clearzone[0][clearcount] = dx - (mtorp_width/2);
		clearzone[1][clearcount] = dy - (mtorp_height/2);
		clearzone[2][clearcount] = mtorp_width;
		clearzone[3][clearcount] = mtorp_height;
		clearcount++;
	    }
	}
    }
    /* Draw plasma torps */
    view = SCALE * WINSIDE / 2;
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if (!j->p_nplasmatorp)
	    continue;
	for (h=0, pt = &plasmatorps[MAXPLASMA * i + h]; h < MAXPLASMA; h++, pt++) {
	    if (!pt->pt_status)
		continue;
	    dx = pt->pt_x - me->p_x;
	    dy = pt->pt_y - me->p_y;
	    if (dx > view || dx < -view || dy > view || dy < -view)
		continue;
	    dx = dx / SCALE + WINSIDE / 2;
	    dy = dy / SCALE + WINSIDE / 2;
	    if (pt->pt_status == PTEXPLODE) {
		pt->pt_fuse--;
		if (pt->pt_fuse <= 0) {
		    pt->pt_status=PTFREE;
		    j->p_nplasmatorp--;
		    continue;
		}
		if (pt->pt_fuse>=NUMDETFRAMES) {
		    pt->pt_fuse=NUMDETFRAMES-1;
		}
		W_WriteBitmap(dx - (plasmacloud_width/2),
		     dy - (plasmacloud_height/2), 
		     plasmacloud[pt->pt_fuse], plasmatorpColor(pt));
		clearzone[0][clearcount] = dx - (plasmacloud_width/2);
		clearzone[1][clearcount] = dy - (plasmacloud_height/2);
		clearzone[2][clearcount] = plasmacloud_width;
		clearzone[3][clearcount] = plasmacloud_height;
		clearcount++;
	    }
	    else if (pt->pt_owner != me->p_no && ((pt->pt_war & me->p_team) ||
		      (players[pt->pt_owner].p_team & (me->p_hostile | me->p_swar))))
	    {
		W_WriteBitmap(dx - (eplasmatorp_width/2),
		     dy - (eplasmatorp_height/2), 
		     eplasmatorp, plasmatorpColor(pt));
		clearzone[0][clearcount] = dx - (eplasmatorp_width/2);
		clearzone[1][clearcount] = dy - (eplasmatorp_height/2);
		clearzone[2][clearcount] = eplasmatorp_width;
		clearzone[3][clearcount] = eplasmatorp_height;
		clearcount++;
	    }
	    else {
		W_WriteBitmap(dx - (mplasmatorp_width/2),
		     dy - (mplasmatorp_height/2), 
		     mplasmatorp, plasmatorpColor(pt));
		clearzone[0][clearcount] = dx - (mplasmatorp_width/2);
		clearzone[1][clearcount] = dy - (mplasmatorp_height/2);
		clearzone[2][clearcount] = mplasmatorp_width;
		clearzone[3][clearcount] = mplasmatorp_height;
		clearcount++;
	    }
	}
    }
    /* Draw Edges */
    if (me->p_x < (WINSIDE / 2) * SCALE) {
	int	sy, ey;

	dx = (WINSIDE / 2) - (me->p_x) / SCALE;
	sy = (WINSIDE / 2) + (0 - me->p_y) / SCALE;
	ey = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
	if (sy < 0) sy = 0;
	if (ey > WINSIDE - 1) ey = WINSIDE - 1;
	W_MakeLine(w, dx, sy, dx, ey, warningColor);
	clearline[0][clearlcount] = dx;
	clearline[1][clearlcount] = sy;
	clearline[2][clearlcount] = dx;
	clearline[3][clearlcount] = ey;
	clearlcount++;
    }
    if ((GWIDTH - me->p_x) < (WINSIDE / 2) * SCALE) {
	int	sy, ey;

	dx = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
	sy = (WINSIDE / 2) + (0 - me->p_y) / SCALE;
	ey = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
	if (sy < 0) sy = 0;
	if (ey > WINSIDE - 1) ey = WINSIDE - 1;
	W_MakeLine(w, dx, sy, dx, ey, warningColor);
	clearline[0][clearlcount] = dx;
	clearline[1][clearlcount] = sy;
	clearline[2][clearlcount] = dx;
	clearline[3][clearlcount] = ey;
	clearlcount++;
    }
    if (me->p_y < (WINSIDE / 2) * SCALE) {
	int	sx, ex;

	dy = (WINSIDE / 2) - (me->p_y) / SCALE;
	sx = (WINSIDE / 2) + (0 - me->p_x) / SCALE;
	ex = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
	if (sx < 0) sx = 0;
	if (ex > WINSIDE - 1) ex = WINSIDE - 1;
	W_MakeLine(w, sx, dy, ex, dy, warningColor);
	clearline[0][clearlcount] = sx;
	clearline[1][clearlcount] = dy;
	clearline[2][clearlcount] = ex;
	clearline[3][clearlcount] = dy;
	clearlcount++;
    }
    if ((GWIDTH - me->p_y) < (WINSIDE / 2) * SCALE) {
	int	sx, ex;

	dy = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
	sx = (WINSIDE / 2) + (0 - me->p_x) / SCALE;
	ex = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
	if (sx < 0) sx = 0;
	if (ex > WINSIDE - 1) ex = WINSIDE - 1;
	W_MakeLine(w, sx, dy, ex, dy, warningColor);
	clearline[0][clearlcount] = sx;
	clearline[1][clearlcount] = dy;
	clearline[2][clearlcount] = ex;
	clearline[3][clearlcount] = dy;
	clearlcount++;
    }

    /* Change border color to signify alert status */

    if (oldalert != (me->p_flags & (PFGREEN|PFYELLOW|PFRED))) {
        oldalert = (me->p_flags & (PFGREEN|PFYELLOW|PFRED));
	switch (oldalert) {
	    case PFGREEN:
		W_ChangeBorder(baseWin, gColor);
		W_ChangeBorder(iconWin, gColor);
		break;
	    case PFYELLOW:
		W_ChangeBorder(baseWin, yColor);
		W_ChangeBorder(iconWin, yColor);
		break;
	    case PFRED:
		W_ChangeBorder(baseWin, rColor);
		W_ChangeBorder(iconWin, rColor);
		break;
	}
    }
}

map()
{
    register int i;
    register struct player *j;
    register struct planet *l;
    int dx, dy;

    if (redrawall) W_ClearWindow(mapw);
    /* Erase ships */
    else for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	lastUpdate[i]++;
	/* Erase the guy if:
	 * redrawPlayer[i] is set and the mapmode setting allows it.
	 */
	if (!redrawPlayer[i] || (mapmode==1 && lastUpdate[i]<5))
	    continue;
	lastUpdate[i]=0;
	/* Clear his old image... */
	if (mclearzone[2][i]) {
	    W_ClearArea(mapw, mclearzone[0][i], mclearzone[1][i],
		mclearzone[2][i], mclearzone[3][i], backColor);
	    /* Redraw the hole just left next update */
	    checkRedraw(mclearzone[4][i], mclearzone[5][i]);
	    mclearzone[2][i]=0;
	}
    }
    /* Draw Planets */
    for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++) {
	if (!(l->pl_flags & PLREDRAW) && (!redrawall))
	    continue;
	l->pl_flags &= ~PLREDRAW; 	/* Turn redraw flag off! */
	dx = l->pl_x * WINSIDE / GWIDTH;
	dy = l->pl_y * WINSIDE / GWIDTH;
	W_ClearArea(mapw, dx - (mplanet_width/2), dy - (mplanet_height/2), 
	    mplanet_width, mplanet_height, backColor);
	W_WriteBitmap(dx - (mplanet_width/2), dy - (mplanet_height/2),
	    planetmBitmap(l), planetColor(l));
	W_WriteText(mapw, dx - (mplanet_width/2), dy + (mplanet_height/2),
	    planetColor(l), l->pl_name, 3, planetFont(l));
    }
    /* Draw ships */
    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	/* We draw the guy if redrawall, or we just erased him.
	 * Also, we redraw if we haven't drawn for 30 frames.
	 * (in case he was erased by other ships).
	 */
	if (lastUpdate[i]!=0 && (!redrawall) && lastUpdate[i]<30) 
	    continue;
	if (j->p_status != PALIVE) 
	    continue;
	lastUpdate[i]=0;
	dx = j->p_x * WINSIDE / GWIDTH;
	dy = j->p_y * WINSIDE / GWIDTH;
	if (j->p_flags & PFCLOAK) {
	    W_WriteText(mapw, dx - W_Textwidth,
		dy - W_Textheight/2, unColor, "??", 2, W_RegularFont);
	} else {
	    W_WriteText(mapw, dx - W_Textwidth, 
		dy - W_Textheight/2, playerColor(j), j->p_mapchars, 2,
		shipFont(j));
	}

	mclearzone[0][i] = dx - W_Textwidth;
	mclearzone[1][i] = dy - W_Textheight/2;
	mclearzone[2][i] = W_Textwidth * 2;
	mclearzone[3][i] = W_Textheight;
	/* Set these so we can checkRedraw() next time */
	mclearzone[4][i] = j->p_x;
	mclearzone[5][i] = j->p_y;
	redrawPlayer[i]=0;
    }
    redrawall = 0;
}

stline(flag)
int flag;
{
    static char buf1[80];
    static char buf2[80];
    static char whichbuf=0;
    register char *buf, *oldbuf;
    register char *s;
    register int i,j;
    int k;

    /* Instead of one sprintf, we do all this by hand for optimization */

    if (flag) whichbuf=0;	/* We must completely refresh */

    if (whichbuf!=2) {
	buf=buf1;
	oldbuf=buf2;
    } else {
	buf=buf2;
	oldbuf=buf1;
    }
    buf[0] = (me->p_flags & PFSHIELD ? 'S': ' ');
    if (me->p_flags & PFGREEN)
	buf[1] = 'G';
    else if (me->p_flags & PFYELLOW)
	buf[1] = 'Y';
    else if (me->p_flags & PFRED)
	buf[1] = 'R';
    buf[2] = (me->p_flags & (PFPLLOCK | PFPLOCK) ? 'L': ' ');
    buf[3] = (me->p_flags & PFREPAIR ? 'R': ' ');
    buf[4] = (me->p_flags & PFBOMB ? 'B': ' ');
    buf[5] = (me->p_flags & PFORBIT ? 'O': ' ');
    if (me->p_ship.s_type == STARBASE)
	buf[6] = (me->p_flags & PFDOCKOK ? 'D' : ' ');
    else
	buf[6] = (me->p_flags & PFDOCK ? 'D' : ' ');
    buf[7] = (me->p_flags & PFCLOAK ? 'C': ' ');
    buf[8] = (me->p_flags & PFWEP ? 'W': ' ');
    buf[9] = (me->p_flags & PFENG ? 'E': ' ');
    if (me->p_flags & PFPRESS)
       buf[10] = 'P';
    else if (me->p_flags & PFTRACT)
       buf[10] = 'T';
    else
       buf[10] = ' ';
    if (me->p_flags & PFBEAMUP)
	buf[11] = 'u';
    else if (me->p_flags & PFBEAMDOWN)
	buf[11] = 'd';
    else
	buf[11] = ' ';
    buf[12] = (status->tourn) ? 't' : ' ';
    buf[13] = ' ';
    buf[14] = '0' + ((me->p_speed % 100) / 10);
    if (buf[14] == '0')
	buf[14] = ' ';
    buf[15] = '0' + (me->p_speed % 10);	/* speed */
    buf[16] = ' ';
    buf[17] = ' ';
    buf[18] = '0' + (me->p_damage / 100);
    if (buf[18] == '0')
	buf[18] = ' ';
    buf[19] = '0' + ((me->p_damage % 100) / 10);
    if ((buf[19] == '0') && (me->p_damage < 100))
	buf[19] = ' ';
    buf[20] = '0' + (me->p_damage % 10);
    buf[21] = ' ';
    buf[22] = '0' + (me->p_shield / 100);
    if (buf[22] == '0')
	buf[22] = ' ';
    buf[23] = '0' + ((me->p_shield % 100) / 10);
    if ((buf[23] == '0') && (me->p_shield < 100))
	buf[23] = ' ';
    buf[24] = '0' + (me->p_shield % 10);
    buf[25] = ' ';
    buf[26] = ' ';
    buf[27] = '0' + ((me->p_ntorp % 100) / 10);
    if (buf[27] == '0')
	buf[27] = ' ';
    buf[28] = '0' + (me->p_ntorp % 10);
    buf[29] = ' ';
    buf[30] = ' ';
    buf[31] = ' ';
    buf[32] = ' ';
    buf[33] = '0' + ((int) (me->p_kills / 10));
    if (buf[33] == '0')
	buf[33] = ' ';
    buf[34] = '0' + (((int) me->p_kills) % 10);
    buf[35] = '.';
    buf[36] = '0' + (((int) (me->p_kills * 10)) % 10);
    buf[37] = '0' + (((int) (me->p_kills * 100)) % 10);
    buf[38] = ' ';
    buf[39] = ' ';
    buf[40] = ' ';
    buf[41] = '0' + ((me->p_armies % 100) / 10);
    if (buf[41] == '0')
	buf[41] = ' ';
    buf[42] = '0' + (me->p_armies % 10);
    buf[43] = ' ';
    buf[44] = ' ';
    buf[45] = ' ';

    buf[46] = '0' + (me->p_fuel / 100000);
    if (buf[46] == '0')
	buf[46] = ' ';
    buf[47] = '0' + ((me->p_fuel % 100000) / 10000);
    if ((buf[47] == '0') && (me->p_fuel < 100000))
	buf[47] = ' ';
    buf[48] = '0' + ((me->p_fuel % 10000) / 1000);
    if ((buf[48] == '0') && (me->p_fuel < 10000))
	buf[48] = ' ';
    buf[49] = '0' + ((me->p_fuel % 1000) / 100);
    if ((buf[49] == '0') && (me->p_fuel < 1000))
	buf[49] = ' ';
    buf[50] = '0' + ((me->p_fuel % 100) / 10);
    if ((buf[50] == '0') && (me->p_fuel < 100))
	buf[50] = ' ';
    buf[51] = '0' + (me->p_fuel % 10);
    buf[52] = ' ';
    buf[53] = ' ';
    buf[54] = ' ';

    buf[55] = '0' + ((me->p_wtemp / 10) / 100);
    if (buf[55] == '0')
	buf[55] = ' ';
    buf[56] = '0' + (((me->p_wtemp / 10) % 100) / 10);
    if ((buf[56] == '0') && (me->p_wtemp < 1000))
	buf[56] = ' ';
    buf[57] = '0' + ((me->p_wtemp / 10) % 10);

    buf[58] = ' ';
    buf[59] = ' ';
    buf[60] = ' ';

    buf[61] = '0' + ((me->p_etemp / 10) / 100);
    if (buf[61] == '0')
	buf[61] = ' ';
    buf[62] = '0' + (((me->p_etemp / 10) % 100) / 10);
    if ((buf[62] == '0') && (me->p_etemp < 1000))
	buf[62] = ' ';
    buf[63] = '0' + ((me->p_etemp / 10) % 10);

    if (whichbuf==0) {
	/* Draw status line */
	W_WriteText(tstatw, 50, 16, textColor, buf, 64, W_RegularFont);
	whichbuf=1;
    } else {	/* Hacks to make it print only what is necessary */
	whichbuf=3-whichbuf;
	j= -1;
	for (i=0; i<64; i++) {
	    if (*(buf++) != *(oldbuf++)) {
		/* Different string */
		if (j==-1) {
		    k=i;
		    s=buf-1;
		}
		j=0;
	    } else {
		/* Same string */
		if (j==-1) continue;
		j++;
		if (j==20) {	/* Random number */
		    W_WriteText(tstatw, 50+W_Textwidth*k, 16, textColor,
			s, i-k-19, W_RegularFont);
		    j= -1;
		}
	    }
	}
	if (j!=-1) {
	    W_WriteText(tstatw, 50+W_Textwidth*k, 16, textColor, s, i-k-j,
		W_RegularFont);
	}
    }
}

newcourse(x, y)
int x, y;
{
    return((unsigned char) (atan2((double) (x - me->p_x),
	(double) (me->p_y - y)) / 3.14159 * 128.));
}

redrawTstats()
{
    char	buf[BUFSIZ];

    W_ClearWindow(tstatw);
    stline(1);	/* This is for refresh.  We redraw player stats too */
    sprintf(buf, 
	"Flags        Warp Dam Shd Torps  Kills Armies   Fuel  Wtemp Etemp");
    W_WriteText(tstatw, 50, 5, textColor, buf, strlen(buf), W_RegularFont);
    sprintf(buf,
	   "Maximum:      %2d  %3d %3d               %3d   %6d   %3d   %3d",
	   me->p_ship.s_maxspeed, me->p_ship.s_maxdamage,
	   me->p_ship.s_maxshield, me->p_ship.s_maxarmies, 
	   me->p_ship.s_maxfuel, me->p_ship.s_maxwpntemp/10, 
	   me->p_ship.s_maxegntemp/10);
    W_WriteText(tstatw, 50, 27, textColor, buf, strlen(buf), W_RegularFont);
}
