/*
 * enter.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

/* Enter the game */

long random();

enter(tno, disp, pno, s_type)
int tno;
char	*disp;
int pno;
int s_type;
{
    static int lastteam= -1;
    static int lastrank= -1;
    char buf[80];
    char addrbuf[10];
    int startplanet;

    (void) strncpy(me->p_name, pseudo, sizeof (me->p_name));
    me->p_name[sizeof(me->p_name) - 1] = '\0';
    getship(myship, s_type);
    /* Need 2 kills to use plasma torpedoes */
    if ((s_type != STARBASE) && (s_type != ATT) && plkills>0) {
	me->p_ship.s_plasmacost = -1;
    }
    me->p_updates = 0;
    me->p_flags = PFSHIELD;
    if (s_type==STARBASE) me->p_flags |= PFDOCKOK;
    me->p_dir = 0;
    me->p_desdir = 0;
    me->p_speed = 0;
    me->p_desspeed = 0;
    me->p_subspeed = 0;
    me->p_team = (1 << tno);
    for (;;) {
	startplanet=tno*10 + random() % 10;
	if (startplanets[startplanet]) break;
    }
    me->p_x = planets[startplanet].pl_x + (random() % 10000) - 5000;
    me->p_y = planets[startplanet].pl_y + (random() % 10000) - 5000;
    if (me->p_x < 0) me->p_x=0;
    if (me->p_y < 0) me->p_y=0;
    if (me->p_x > GWIDTH) me->p_x = GWIDTH;
    if (me->p_y > GWIDTH) me->p_y = GWIDTH;
    me->p_ntorp = 0;
    me->p_cloakphase = 0;
    me->p_nplasmatorp = 0;
    me->p_damage = 0;
    me->p_subdamage = 0;
    me->p_etemp = 0;
    me->p_etime = 0;
    me->p_wtemp = 0;
    me->p_wtime = 0;
    me->p_shield = me->p_ship.s_maxshield;
    me->p_subshield = 0;
    me->p_swar = 0;
    if (!keeppeace) me->p_hostile = (FED|ROM|KLI|ORI);
    me->p_hostile &= ~me->p_team;
    me->p_kills = 0.0;
    me->p_armies = 0;
    me->p_docked = 0;
    me->p_port[0] = VACANT;
    me->p_port[1] = VACANT;
    me->p_port[2] = VACANT;
    me->p_port[3] = VACANT;

    sprintf(buf, "%c%c", teamlet[me->p_team], shipnos[me->p_no]);
    strncpy(me->p_mapchars, buf, 2);
    if (lastteam != tno || lastrank != mystats->st_rank) {
	char buf[80];

	lastteam=tno;
	lastrank=mystats->st_rank;
	sprintf(buf, "%s %.16s joining as %2.2s (%.16s@%.16s)", 
	    ranks[me->p_stats.st_rank].name, 
	    me->p_name, 
	    me->p_mapchars, 
	    me->p_login,
	    me->p_monitor);
	sprintf(addrbuf, " %c%c->ALL", 
	    teamlet[me->p_team], shipnos[me->p_no]);
	pmessage2(buf, 0, MALL, addrbuf, me->p_no);
    }

    me->p_fuel = myship->s_maxfuel;
    delay = 0;
}

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    perror("shmget");
	    exit(1);
	}
	startdaemon();
	sleep(2);		/* ATM: was 2; not long enough? */
	sleep(1);		/* ATM: wake up & then sleep again */
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	perror("shared memory");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    plasmatorps = sharedMemory->plasmatorps;
    status = sharedMemory->status;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}

