/*
 * main.c
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
/* #include "templates.h" */
#include "packets.h"

jmp_buf env;
static startTarms, startTplanets;

main(argc, argv)
int argc;
char **argv;
{
    int intrupt();
    int team, s_type;
    int pno, overload=0;  /* overload indicates a request for a reserved slot */
    int usage = 0;
    int err = 0;
    char *cp, *name, *ptr, *rindex();
    char buf[80];
    struct passwd *pwent, *getpwuid();
    int reaper();
    int callHost=0;
    long starttime;

    name = *argv++;
    argc--;
    if ((ptr = rindex(name, '/')) != NULL)
	name = ptr + 1;
    while (*argv) {
	if (**argv == '-')
	    ++*argv;
	else
	    break;

	argc--;
	ptr = *argv++;
	while (*ptr) {
	    switch (*ptr) {
	    case 'u': usage++; break;
	    case 'R': if (getuid()==geteuid()) overload++; break;
	    case 's': xtrekPort=atoi(*argv); callHost=1; argv++; argc--; break;
	    case 'd':
		host = *argv;
		argc--;
		argv++;
		break;
	    default: 
		fprintf(stderr, "%s: unknown option '%c'\n", name, *ptr);
		err++;
		break;
	    }
	    ptr++;
	}
    }
    if (usage || err) {
	printUsage(name);
	exit(err);
    }
    /* compatability */
    if (argc > 0)
	host = argv[0];
    srandom(getpid() * time((long *) 0));
    readsysdefaults();
    /* this finds the shared memory information */
    openmem();
    if (callHost) {
	if (!connectToClient(host,xtrekPort)) {
	    exit(0);
	}
    } else {
	sock=0;	/* Because we were forked by inetd! */
	checkSocket();
	initClientData();	/* "normally" called by connectToClient() */
    }
    starttime=time(NULL);
    while (userVersion==0) {
	/* Waiting for user to send his version number.
	 * We give him ten seconds to do so...
	 */
	if (starttime+10 < time(NULL)) {
	    exit(1);
	}
	socketPause();
	readFromClient();
    }
    if (!checkVersion()) exit(1);
    sendMotd();
    pno = findslot(overload);
    if (pno < 0) {
	/* print some appropriate message */
	exit(1);
    }
    me = &players[pno];
    me->p_no=pno;
    myship = &me->p_ship;
    mystats = &me->p_stats;
    lastm = mctl->mc_current;
    sigset(SIGHUP, SIG_IGN);		/* ATM */
    sigset(SIGINT, SIG_IGN);
    (void) signal(SIGCHLD, reaper);

    /* We set these so we won't bother updating him on the location of the
     *  other players in the galaxy which he is not near.  There is no
     *  real harm to doing this, except that he would then get more information
     *  than he deserves.
     * It is kind of a hack, but should be harmless.
     */
    me->p_x= -100000;	
    me->p_y= -100000;
    me->p_team=0;
    updateSelf();	/* so he gets info on who he is */
    updateShips();
    updatePlanets();
    flushSockBuf();

    /* Get login name */
    if ((pwent = getpwuid(getuid())) != NULL)
	(void) strncpy(login, pwent->pw_name, sizeof(login));
    else
	(void) strncpy(login, "Mystery", sizeof(login));
    login[sizeof(login) - 1] = '\0';

    strcpy(pseudo, "Guest");

    strcpy(me->p_name, pseudo);
    me->p_team=ALLTEAM;
    getname();
    strcpy(pseudo, me->p_name);
    keeppeace = (me->p_stats.st_flags / ST_KEEPPEACE) & 1;

    /* Set p_hostile to hostile, so if keeppeace is on, the guy starts off
       hating everyone (like a good fighter should) */
    me->p_hostile = (FED|ROM|KLI|ORI);

    s_type = CRUISER;
    me->p_planets=0;
    me->p_genoplanets=0;
    me->p_armsbomb=0;
    me->p_genoarmsbomb=0;
    /* Set up a reasonable default */
    me->p_whydead=KQUIT;
/*    logEntry();*/		/* ATM - a little later */

    (void) strncpy(me->p_login, login, sizeof (me->p_login));
    me->p_login[sizeof(me->p_login) - 1] = '\0';
    (void) strncpy(me->p_monitor, host, sizeof(me->p_monitor));
    me->p_monitor[sizeof(me->p_monitor) - 1] = '\0';
    logEntry();

    startTarms=me->p_stats.st_tarmsbomb;
    startTplanets=me->p_stats.st_tplanets;
    setjmp(env);		/* Reentry point of game */
	/* give the player the motd and find out which team he wants */
    if (me->p_status != PALIVE) {
	me->p_x= -100000;
	me->p_y= -100000;
	updateSelf();
	updateShips();
	teamPick= -1;
	flushSockBuf();
	getEntry(&team, &s_type);
	repCount=0;		/* Make sure he gets an update immediately */
    }
    if (team == -1) {
	exitGame();
    }
    redrawall = 1;
    inputMask= -1;	/* Allow all input now */
    enter(team, host, pno, s_type);
    /*
    for (i = 0; i < NSIG; i++) {
	sigset(i, SIG_IGN);
    }
    */

    me->p_status = PALIVE;			/* Put player in game */
    me->p_ghostbuster = 0;

    /* Get input until the player quits or dies */
    input();
}

exitGame()
{
    char buf[80];
    char addrbuf[20];

    if (me != NULL && me->p_team != ALLTEAM) {
	sprintf(buf, "%s %s (%s) leaving the game (%.16s@%.16s)", 
	    ranks[me->p_stats.st_rank].name,
	    me->p_name,
	    me->p_mapchars, 
	    me->p_login,
	    me->p_monitor);
        sprintf(addrbuf, " %c%c->ALL",
	   teamlet[me->p_team], shipnos[me->p_no]);
	pmessage2(buf, 0, MALL, addrbuf, me->p_no);
	savestats();
	printStats();
    }
    me->p_status = PFREE;
    strcpy(me->p_name, "-");		/* ATM */
    strcpy(me->p_login, "-");
    exit(0);
}
    

printUsage(prog)
	char	*prog;
{
	printf("Usage: %s [-u] -s socket# machine\n",
		prog);
}

sendMotd()
{
    static char *shiptypes[NUM_TYPES] = {"SC","DD","CA","BB","AS","SB","??"};
    FILE *motd;
    char buf[100];	/* big enough... */
    int i, flag, length;

    /* the following will read a motd */
    if ((motd = fopen(MOTD, "r")) != NULL) {
	while (fgets(buf, sizeof (buf), motd) != NULL) {
	    buf[strlen(buf)-1] = '\0';
	    sendMotdLine(buf);
	}
	(void) fclose(motd);
    }

    /* ATM: send current configuration info as well */
    sendMotdLine(STATUS_TOKEN);	/* indicate start of config info */
    if (tournplayers > 8)
	sprintf(buf, "%-30s: disabled", "Tournament Mode");
    else
	sprintf(buf, "%-30s: %d players / side","Tournament Mode",tournplayers);
    sendMotdLine(buf);

    sprintf(buf, "%-30s: ", "Ships Allowed");
    for (i = 0; i < NUM_TYPES; i++) {
	if (i == ATT) continue;
	if (shipsallowed[i]) {
	    strcat(buf, shiptypes[i]);
	    strcat(buf, " ");
	}
    }
    sendMotdLine(buf);

    sprintf(buf, "%-30s: %s", "Plasma Torpedoes",
	weaponsallowed[0] ? "enabled" : "disabled");
    sendMotdLine(buf);

    sprintf(buf, "%-30s: %s", "Tractor/Pressor Beams",
	weaponsallowed[1] ? "enabled" : "disabled");
    sendMotdLine(buf);

    if (weaponsallowed[0]) {
	sprintf(buf, "%-30s: %d", "Kills Required for Plasma", plkills);
	sendMotdLine(buf);
    }

    if (shipsallowed[STARBASE]) {
	sprintf(buf, "%-30s: %s (%d)", "Rank Required for SB",
		ranks[sbrank].name, sbrank);
	sendMotdLine(buf);
    }

    sprintf(buf, "%-30s: ", "Hidden Mode");
    switch (hiddenenemy) {
    case 0:
	strcat(buf, "inactive");
	break;
    case 1:
	strcat(buf, "tournament only");
	break;
    case 2:
	strcat(buf, "active");
	break;
    }
    sendMotdLine(buf);

    flag = 0;		/* see if non-home worlds are allowable entry points */
    for (i = 0; i < MAXPLANETS; i++) {
	if (startplanets[i] && (i % 10)) {
	    flag = 1;
	    break;
	}
    }
    sprintf(buf, "%-30s: %s", "Multiple Entry Planets", flag ? "yes" : "no");
    sendMotdLine(buf);

    sprintf(buf, "%-30s: %s", "Chaos Mode", chaos ? "enabled" : "disabled");
    sendMotdLine(buf);

    sprintf(buf, "%-30s: ", "Verification");
    switch (binconfirm) {
    case 0:
	strcat(buf, "disabled");
	break;
    case 1:
	strcat(buf, "enabled");
	break;
    case 2:
	strcat(buf, "cyborgs allowed");
	break;
    }
    sendMotdLine(buf);
}

reaper(sig)
{
    int id;

    /* have to use signal(); sigset() doesn't cut it */
    /* (problem is a messed up wait3())              */
    (void) signal(sig, SIG_IGN);	/* ATM: mask signals for now */

    while ((id = wait3((union wait *) 0, WNOHANG, (struct rusage *) 0)) > 0)
	;
    signal(sig, reaper);		/* ATM: reset signal handler */
}

printStats()
{
    int i;
    FILE *logfile;
    int curtime;

    logfile=fopen(LOGFILENAME, "a");
    if (!logfile) return;
    curtime=time(NULL);
    fprintf(logfile, "Leaving: %s (%s@%s) (%c%c), [%d, %d, %d] %s", 
	me->p_name, 
	me->p_login, 
	me->p_monitor, 
	teamlet[me->p_team],
	shipnos[me->p_no], 
	me->p_stats.st_tplanets - startTplanets,
	me->p_stats.st_tarmsbomb - startTarms,
	numPlanets(me->p_team),
	ctime(&curtime));
    fclose(logfile);
}

