/*
 *  Kevin P. Smith      12/05/88
 *
 *  Takes the output of scores A and generates the player file.
 *  (Also creates the .GLOBAL file)
 *  This program reads stdin for its data.
 */

#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>		/* ATM */
#include <sys/file.h>
#include <pwd.h>
#include "defs.h"
#include "struct.h"
char *malloc();

struct statentry player;
struct status *status;
struct rawdesc *output=NULL;
char mode;

trimblanks2(str)
char *str;
{
    *str=0;
    str--;
    while (*str==' ') {
	*str=0;
	str--;
    }
    if (*str=='_') *str=0;
}

trimblanks(str)
char *str;
{
    *str=0;
    str--;
    while (*str==' ') {
	*str=0;
	str--;
    }
}

main(argc, argv)
int argc;
char **argv;
{
    int fd;
    struct player j;
    int i;
    char buf[512];

    if (argc>1) usage();
    printf("Warning:  If you do not know how to use this program, break it now!\n");
    status=(struct status *) malloc(sizeof(struct status));
    scanf("%10ld %10d %10d %10d %10d %10ld\n", 
	&status->time, 
	&status->planets, 
	&status->armsbomb, 
	&status->kills, 
	&status->losses,
	&status->timeprod);

    fd = open(GLOBAL, O_WRONLY|O_CREAT|O_TRUNC, 0600);
    if (fd < 0) {
	printf("Cannot open the global file!\n");
	exit(0);
    }
    write(fd, (char *) status, sizeof(struct status));
    close(fd);

    fd = open(PLAYERFILE, O_WRONLY|O_CREAT|O_TRUNC, 0600);
    if (fd < 0) {
	perror(PLAYERFILE);
	exit(1);
    }

    while (gets(buf)) {
	trimblanks2(buf+16);
	trimblanks(buf+33);
	trimblanks(buf+129);
	strcpy(player.name, buf);
	strcpy(player.password, buf+17);
	strcpy(player.stats.st_keymap, buf+34);
	sscanf(buf+130, " %d %lf %d %d %d %d %d %d %d %d %d %d %d %d %d %lf %ld %d\n",
	    &player.stats.st_rank,
	    &player.stats.st_maxkills,
	    &player.stats.st_kills,
	    &player.stats.st_losses,
	    &player.stats.st_armsbomb,
	    &player.stats.st_planets,
	    &player.stats.st_ticks,
	    &player.stats.st_tkills,
	    &player.stats.st_tlosses,
	    &player.stats.st_tarmsbomb,
	    &player.stats.st_tplanets,
	    &player.stats.st_tticks,
	    &player.stats.st_sbkills,
	    &player.stats.st_sblosses,
	    &player.stats.st_sbticks,
	    &player.stats.st_sbmaxkills,
	    &player.stats.st_lastlogin,
	    &player.stats.st_flags);
	write(fd, (char *) &player, sizeof(struct statentry));
    }
    exit(0);
}

usage()
{
    printf("Usage: newscores < scoredb\n");
    printf("This program takes input of the form generated by the 'scores A'\n");
    printf(" command.  This allows you to create an ascii form of the database\n");
    printf(" with 'scores A > scoredb', then you can edit it as needed, then you\n");
    printf(" can issue a 'newscores < scoredb' command to restore the database.\n");
    printf("Note:  The form of the output from the 'scores A' command is very\n");
    printf(" specific.  Be sure that the input stream matches it very accurately\n");
    exit(0);
}
