#include <X11/Xlib.h>		/* ATM */
#include <stdio.h>
/*#include "/usr/att/usr/include/string.h"*/
#include <string.h>		/* ATM */
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/ipc.h>
/*#include "/usr/att/usr/include/sys/shm.h"*/
#include <sys/shm.h>		/* ATM */
#include <math.h>
#include <sys/file.h>
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"

struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    perror("shmget");
	    exit(1);
	}
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	perror("shared memory");
	exit (1);
    }
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}

int theteam[9];
int armies[9];
char *teamchars[] = {"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI"};

main()
{
    int i;

    openmem();
    for (i=0; i<40; i++) {
	printf("%2d: (%s) %-16s %4d %-7.7s %-4.4s %-4.4s %c%c%c%c\n",
	    i, teamchars[planets[i].pl_owner],
	    planets[i].pl_name,
	    planets[i].pl_armies,
	    planets[i].pl_flags & PLREPAIR ? "REPAIR" : "",
	    planets[i].pl_flags & PLFUEL ? "FUEL" : "",
	    planets[i].pl_flags & PLAGRI ? "AGRI" : "",
	    planets[i].pl_info & FED ? 'F' : ' ',
	    planets[i].pl_info & ROM ? 'R' : ' ',
	    planets[i].pl_info & KLI ? 'K' : ' ',
	    planets[i].pl_info & ORI ? 'O' : ' ');
	theteam[planets[i].pl_owner]++;
	if (planets[i].pl_armies > 4) { 
	    armies[planets[i].pl_owner] += planets[i].pl_armies-4;
	}
    }
    printf("Planets:\n");
    printf("IND: %d  FED: %d  ROM: %d  KLI: %d  ORI: %d\n",
	theteam[0], theteam[1], theteam[2], theteam[4], theteam[8]);
    printf("Spare armies:\n");
    printf("IND: %d  FED: %d  ROM: %d  KLI: %d  ORI: %d\n",
	armies[0], armies[1], armies[2], armies[4], armies[8]);
}
